#include <iostream.h>

typedef struct date {
 unsigned int day :5;
 unsigned int month :4;
 unsigned int year :7;
};

unsigned int date_to_int (date d) {
 return (d.day<<11)|(d.month<<7)|(d.year & 0x007F);
}

date int_to_date (unsigned int n) {
 date d;
 d.day=(n&0xF800)>>11;
 d.month=(n&0x0780)>>7;
 d.year=n&0x007F;
 return d;
}

void main () {
 date d = { 1, 1, 2013-1970 };
 cout << "\n" << date_to_int(d);
 d=int_to_date (2219);
 cout << "\n" << d.day << "." << d.month << "." << d.year+1970;
 cin.get();
}













