#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef enum status { undefined, dependent, pupil, working, pensioner };
char *get_status (status s) {
 char *status_strings[] = { "undefined", "dependent", "pupil", "working", "pensioner" };
 return status_strings[s];
}

typedef struct passport {
 unsigned int series;
 unsigned long int number;
};

typedef struct date {
 unsigned int day :5;
 unsigned int month :4;
 unsigned int year :7; // 1970=0... 2098
};

union udate {
 date d;
 unsigned int u;
};

typedef struct person {
 char *name; //᫨ ࠧ name[30] -  諮  뤥   name
 status status;
 passport passport;
 date date;
}; 

void error (char *msg) {
 puts ("\n"); puts (msg); puts ("\nEnter to EXIT");
 fflush (stdin); getchar(); exit(0);
}

void main () {
 const int maxrecords=5; //ᨬ쭮 ᫮ ᥩ
 person p[maxrecords]; //ᨢ  -    
 char buf[128],name[40]; //  ⥭ ப   ⤥쭮 - , ..  㤥 뤥
 FILE *f=fopen ("data.txt","r+t"); //"" 㤥 ⥪⮢ 䠩 data.txt  ⥪饩 
 if (f==NULL) error("Can't open data.txt"); //᫨  㤠  - 室
 int count=0; //稪 ᥩ
 while (1) { //   ⥭ ⥪⮢ 䠩  Windows  Ctrl+Z  
  fgets (buf,128,f); //⠥ ࠧ ப
  sscanf (buf,"%s %d %d %ld %u",name,&p[count].status,&p[count].passport.series,&p[count].passport.number,&p[count].date);
   // ࠧࠥ    
  p[count].name = new char[strlen(name)+1]; //뤥塞    ""
  if (p[count].name==NULL) { //᫨  㤠 뤥  - 室
   sprintf (buf,"No memory for rec. no. %d",count+1); error (buf); 
  }
  strcpy(p[count].name,name); //९뢠   ""  
  count++;
  if (feof(f) || count>maxrecords-1) break; //᫨ 稫   ⨣ । - ࢠ
 }
 //襬  䠩 1 , ᫨  ᫥    Newname
 if (count && strcmp(p[count-1].name,"Newname")) {
  udate d = { 22, 1, 2013-1970 };
  fseek (f, 0, SEEK_END);
  fprintf (f, "\n%s %d %d %ld %u","Newname",1,5004,456789,d.u);
 }
 fclose (f);
 // ⠭  䠩 ᨢ ᥩ p
 for (int i=0; i<count; i++)
  printf ("\n%d. %s, %s, %04u %06lu, %02d.%02d.%d",
   i+1, p[i].name, get_status(p[i].status),p[i].passport.series,p[i].passport.number,p[i].date.day, p[i].date.month,
   p[i].date.year+1970);
 error ("");
}




























